/* Shutdown-Daemon -- die Messages muessen wohl nochmal ueberarbeitet werden */
inherit "std/npc";

#include <properties.h>
#include <defines.h>
#include <language.h>
#include <moving.h>

string *messages=
  ({"Blitz und Donner hallen durch die Welt.",
  "Erdbeben erschuettern die Welt und bringen Haeuser zum Einsturz.",
  "Die Einwohner dieser Welt beginnen, vor Deinen Augen zu verschwimmen.",
  "Violette Wolken tuermen sich am Himmel auf ... blutiger Regen faellt hernieder.",
  "Lava aus unzaehligen Vulkanen fliesst und verbrennt, was sie beruehrt.",
  "Die Fluesse und Meere dieser Welt beginnen zu verdampfen.",
  "Der Himmel verdunkelt sich, Sterne und Sonne beginnen zu verloeschen.",
  "Um Dich herum siehst Du nur noch brennende Truemmer. Das Ende der Welt muss nun\nunmittelbar bevorstehen."});

int restzeit;

_query_restzeit()
{
  return restzeit+find_call_out("NextStep");
}

create()
{
  ::create();
  SetProp(P_NAME, "Armageddon");
  SetProp(P_GENDER, MALE);
  SetProp(P_SHORT, "Armageddon, der Weltenvernichter");
  AddId("armageddon");
  set_living_name("armageddon");
  SetProp(P_ARTICLE,0);
}

_query_long()
{
  return break_string("Dies ist Armageddon, der Weltvernichter. Als Du ihn ansiehst, blickt er auf und fluestert Dir zu: Noch "+text_time(_query_restzeit())+" muessen vergehen, ehe ich die Welt vernichte.\n",80,0);
}

text_time(sec,flag)
{
  string s;
  int tage, stunden, minuten, sekunden;
  
  sekunden=sec;
  tage=sekunden/86400;
  stunden=(sekunden%86400)/3600;
  minuten=(sekunden%3600)/60;
  sekunden=sec%60;
  s="";
  if (sec>=86400)
  {
    s+=tage+" Tag"+(tage==1 ? ", " : (flag ? "en, " : "e, "));
  }
  if (sec>=3600)
  {
    s+=stunden+" Stunde"+(stunden==1 ? ", " : "n, ");
  }
  if (sec>=60)
  {
    s+=minuten+" Minute"+(minuten==1 ? "" : "n");
  }
  s+=(sec/60?" und ":" ")+sekunden+" Sekunde"+(sekunden==1 ? "" : "n");
  return s;
}

shut(minutes)
{
  int a,b,c;

  a=b=c=0;
  if (intp(minutes))
    c = minutes;
  
  else if (stringp(minutes))
  {
    if(sscanf(minutes,"%d:%d:%d",a,b,c)==3)
      c += b*60+a*24*60;
    else if(sscanf(minutes,"%d:%d",b,c)==2)
      c += b*60;
    else if(sscanf(minutes,"%d",c)==1)
      ;
  }

  while (remove_call_out("NextStep")>=0);
  restzeit=c*60;
  call_out("NextStep",0,restzeit);
}

SHOUT(str)
{
  int i;
  
  str=explode(break_string(str,60),"\n");
  for (i=0;i<sizeof(str);i++)
  {
    write("Armageddon ruft: "+str[i]+"\n");
    shout("Armageddon ruft: "+str[i]+"\n");
  }
}

static NextStep(seconds)
{
  int rest,neu;
  string time;
  object plakat;

  if (seconds<=0)
  {
    SHOUT("Ich starte das Spiel jetzt neu !");
    shutdown("");
    return;
  }
  if (seconds<=600)
  {
    SHOUT("Teile mir mit, wenn Du in den Laden gebracht werden willst!");
  }
  if (seconds>4800)
    neu=seconds-1800;
  else
    neu=seconds*3/4-10;
  restzeit=neu;
  call_out("NextStep",seconds-neu,neu);
  if (plakat=find_object("/players/catweazle/obj/spendenliste")) {
     rest=12000-(to_int(plakat->GetTotal()));
     time=" Um das MorgenGrauen bis zu diesem Zeitpunkt zu retten, fehlen noch "+rest+" DM.";
	 if (plakat->GetTotal()>12000) time="";
  }
  else time="";
  SHOUT("In "+text_time(seconds,1)+" werde ich die Welt endgueltig vernichten!"+time);
  if (neu<900 && find_call_out("ArmasShout")==-1)
    call_out("ArmasShout",random(99)+5);
  return 1;
}

ArmasShout()
{
  call_out("ArmasShout",36+random(36));
  shout(messages[random(sizeof(messages))]+"\n");
}

catch_tell(str)
{
  string who,what;
  object ob;
  
  if (sscanf(str, "%s teilt Dir mit: %s", who, what) != 2)
    return;
  if (!this_player()) return;
  if (_query_restzeit()<600)
  {
    this_player()->move("/d/ebene/room/PortVain/laden",M_TPORT);
    return 1;
  }
  tell_object(this_player(),"Armageddon teilt Dir mit: Es ist noch zu frueh! Probiers 10 Minuten vor dem\nArmageddon teilt Dir mit: Ende nochmal!\n");
  return 1;
}

int remove()
{
  write("Armageddon doesn't want to be removed!\n");
  return 0;
}
