/*
    Ein Testi-Tool.
    Hilft Testspielern beim Testen von Gebieten dadurch, dass es ihnen viel
    arbeit abnimmt.
    Hiermit koennen die wichtigsten Werte gesetzt werden...

    Als Testspieler kann man sich mit 'bleihelp' eine Hilfe anzeigen lassen.

    Version 1.0
    04.01.2000 12:00:00   Querolin
	
	$Date: 2001/01/13 13:23:55 $
	$Revision: 1.2 $
	$Log: testitool.c,v $
	Revision 1.2  2001/01/13 13:23:55  Samtpfote
	Sicherheitscheck auf Testplayer oder Learner

	Revision 1.1  2001/01/13 13:21:48  Samtpfote
	Initial revision

*/

inherit "std/thing";

#include "/d/elfenwald/def.h" // die passt schon so schoen :) 
#include "/gilden/files.abenteurer/abenteurer.h"
#include <properties.h>
#include <moving.h>
#include <wizlevels.h>

int abgehoben;

create()
{
 if (!is_clone(this_object())) return; 
 ::create();

 SetProp(P_SHORT, "Ein zerbrochener Bleistift");
 SetProp(P_LONG, "Ein absolut nutzloser, weil zerbrochener Bleistift. Nicht "
  +"mal mehr ein Wort wird man mit diesem noch schreiben koennen. Vermutlich "
  +"hat ihn der Besitzer auch nicht mehr gebraucht.\n");
 SetProp(P_GENDER, MALE);
 SetProp(P_WEIGHT, 1);
 SetProp(P_AUTOLOADOBJ, 1);
 SetProp(P_VALUE, 0);
 SetProp(P_NOSELL, 1);
 SetProp(P_NOBUY, 1);

 AddId(({"bleistift", "stift","\ntesti_tool"}));
 SetProp(P_NAME, "Bleistift");
 AddAdjective( ({ "zerbrochen", "zerbrochenen", "zerbrochener" }) );
 SetProp(P_MATERIAL, MAT_CARBON);

 SetProp(P_INFO, BS("Ein ganz gewoehnlicher Bleistift ohne irgendwelche "
   +"Besonderheiten. Auf dem Stift steht 'bleihelp' drauf.\n"));

 AddCmd("bleihelp", "_help");
 AddCmd("setxp", "_setxp");
 AddCmd("heile", "_heile");
 AddCmd("setghost", "_ghost");
 AddCmd("goto", "_goto");
 AddCmd("setalign", "_setalign");
 AddCmd("bankomat", "_muenzen");
 AddCmd("ausruesten", "_ausruesten");
 AddCmd("ausruestung","_ausruestung");
 AddCmd("wegdamit", "_wegdamit");
}

void init()
{
  if(!TP->QueryProp(P_TESTPLAYER) && !IS_LEARNER(TP))
  {
	call_out("remove", 0);
	return;
  }

  ::init();
}

_help()
{
  if (TP->QueryProp(P_TESTPLAYER)!=0)
  {
    write( 
      "  TESTI-Tool\n"
     +"  ----------\n"
     +"   Mit Hilfe dieses Tools koennen Testspieler (markierte nat. nur)\n"
     +"   einige Dinge die sonst nur Magier koennen. Selbstverstaendlich\n"
     +"   koennen Sie diese Dinge nur auf sich selbst anwenden. Der Stift\n"
     +"   funktioniert auch nur bei Testspielern (keine Spieler/Magier)\n"
     +"   Funktionen:\n\n"
     +"      setxp <zahl>    -   Setzt die Erfahrungspunkte auf <zahl>\n"
     +"      heile           -   Heilt (LP und SP) des Testspielers\n"
     +"      ghost [1|0]     -   1 - Setzt Geist / 0 - kein Geist mehr\n"
     +"      goto <name>     -   living_name (Person oder NPC)\n"
     +"      setalign <zahl> -   Setzt P_ALIGN auf <zahl>\n"
     +"      bankomat        -   Kann (beschraenkt!) 5000 Muenzen beheben\n"
     +"      ausruesten      -   Standard Ausruestung holen (ersetzen)\n"
     +"      ausruestung <>  -   weg = alles weg, # = Nummer <x> weg\n"
     +"      wegdamit        -   Bleistift loest sich auf (!)\n"
     +"      bleihelp        -   diese Hilfe\n"
     +"                                              01/2001 by Querolin\n\n");
    return 1;
  }
  return 0;
}

_wegdamit()
{
  remove();
  write("OK Bleistift zerstoert...\n");
  return 1;
}

_goto(string str)
{
  if (TP->QueryProp(P_TESTPLAYER)!=0)
  {
    if (find_living(str))
    {
      TP->move(environment(find_living(str)), M_GO);
      write("Done.\n");
    }
    else
    {
     write("Living not found...\n");
    }
    return 1;
  }
  return 0;
}

_ausruestung(string str)
{
  object ob;
  if (TP->QueryProp(P_TESTPLAYER)!=0)
  {
  if (!str)
  {
    write("\n Liste der Ruestungen die vernichtet werden kann:\n\n"
         +"    1 - Schwert\n"
         +"    2 - Eisenpanzer\n"
         +"    3 - Lederstiefel\n"
         +"    4 - Hose\n"
         +"    5 - Maentelchen\n"
         +"    6 - Guertel\n"
         +"    9 - Abenteurer Abzeichen\n"
         +"    0 - alles ausser Abzeichen\n\n"
         +"   Syntax: ausruestung [1|2|0] zum vernichten der jeweiligen\n"
         +"           Ausruestung.\n\n");
     return 1;
  }
   if ((str=="1") || (str=="0"))
   {
    ob=deep_present("\nschwert",TP);
    if (ob) ob->remove();
   }

   if ((str=="2") || (str=="0"))
   {
    ob=deep_present("\nepanzer",TP);
    if (ob) ob->remove();
   }

   if ((str=="3") || (str=="0"))
   {
    ob=deep_present("\nlederstiefel",TP);
    if (ob) ob->remove();
   }

   if ((str=="4") || (str=="0"))
   {
    ob=deep_present("\ngidhrog_hose",TP);
    if (ob) ob->remove();
   }

   if ((str=="5") || (str=="0"))
   {
    ob=deep_present("\nmaentelchen",TP);
    if (ob) ob->remove();
   }

   if ((str=="6") || (str=="0"))
   {
    ob=deep_present("\nlguertel",TP);
    if (ob) ob->remove();
   }

   if (str=="9")
   {
    ob=deep_present(ABG_ABZEICHEN_ID,TP);
    if (ob) ob->remove();
   }

   write("done.\n");
   return 1;
  }
 return 0;
}

_ausruesten()
{
  object ob;
  if (TP->QueryProp(P_TESTPLAYER)!=0)
  {
    ob=deep_present("\nschwert",TP);
    if (ob) ob->remove();
    ob=clone_object("/d/gidhrog/weapon/schwert");
    ob->SetProp(P_NODROP, 1);
    ob->SetProp(P_NOSELL, 1);
    ob->move(TP, M_NOCHECK);

    ob=deep_present("\nepanzer",TP);
    if (ob) ob->remove();
    ob=clone_object("/d/gidhrog/armour/epanzer");
    ob->SetProp(P_NODROP, 1);
    ob->SetProp(P_NOSELL, 1);
    ob->move(TP, M_NOCHECK);

    ob=deep_present("\nlederstiefel",TP);
    if (ob) ob->remove();
    ob=clone_object("/d/gidhrog/armour/lederstiefel");
    ob->SetProp(P_NODROP, 1);
    ob->SetProp(P_NOSELL, 1);
    ob->move(TP, M_NOCHECK);

    ob=deep_present("\ngidhrog_hose",TP);
    if (ob) ob->remove();
    ob=clone_object("/d/gidhrog/armour/hose");
    ob->SetProp(P_NODROP, 1);
    ob->SetProp(P_NOSELL, 1);
    ob->move(TP, M_NOCHECK);

    ob=deep_present("\nmaentelchen",TP);
    if (ob) ob->remove();
    ob=clone_object("/d/tal/querolin/brownies/armour/maentelchen");
    ob->SetProp(P_NODROP, 1);
    ob->SetProp(P_NOSELL, 1);
    ob->move(TP, M_NOCHECK);

    ob=deep_present("\nlguertel",TP);
    if (ob) ob->remove();
    ob=clone_object("/d/grasland/querolin/hobbits/armour/guertel");
    ob->SetProp(P_NODROP, 1);
    ob->SetProp(P_NOSELL, 1);
    ob->move(TP, M_NOCHECK);

    ob=deep_present(ABG_ABZEICHEN_ID,TP);
    if (!ob) 
    {
    ob=clone_object("/gilden/files.abenteurer/armour/abg_abzeichen");
    ob->SetProp(P_NODROP, 1);
    ob->SetProp(P_NOSELL, 1);
    ob->move(TP, M_NOCHECK);
    }
    
    write("Neu Ausgeruestet!\ndone.\n");
    return 1;
  }
  return 0;
}

_muenzen()
{
  object ob;
  if (TP->QueryProp(P_TESTPLAYER)!=0)
  {
    if (abgehoben==0)
    {
     ob=deep_present("muenzen",TP);
     if (!ob)
     {
      ob=clone_object("/obj/money");
      ob->SetProp(P_AMOUNT, 5000);
      ob->move(TP, M_NOCHECK);
      write("done.\n");
      abgehoben=4;
      return 1;
     }

     if (ob->QueryProp(P_AMOUNT)>3000)
     {
      write("Du hast noch genug Bargeld...\n");
     }
     else 
     {
      ob->SetProp(P_AMOUNT, ob->QueryProp(P_AMOUNT)+5000);
      abgehoben=5;
     }

     write("done.\n");
    }
    else
    {
     write("Leider derzeit kein abheben moeglich...\n");
    }
    return 1;
  }
  return 0;
}


_setxp(int neu)
{
  if (TP->QueryProp(P_TESTPLAYER)!=0)
  {
    neu=to_int(neu);
    if (neu>0) TP->SetProp(P_XP, neu);
    write("done.\n");
    return 1;
  }
}

_setalign(int neu)
{
  if (TP->QueryProp(P_TESTPLAYER)!=0)
  {
    neu=to_int(neu);
    if ( (neu>-1001) && (neu<1001) )
    {
      TP->SetProp(P_ALIGN, neu);
      write("done.\n");
    }
    else
    {
     write("Illegaler Wert fuer Align!\n");
    }
    return 1;
  }
}

_heile()
{
  if (TP->QueryProp(P_TESTPLAYER)!=0)
  {
    TP->SetProp(P_HP, TP->QueryProp(P_MAX_HP) );
    TP->SetProp(P_SP, TP->QueryProp(P_MAX_SP) );
    write("done.\n");
    return 1;   
  }
}

_ghost(string str)
{

  if (TP->QueryProp(P_TESTPLAYER)!=0)
  {
    if (str=="1")
    {
      TP->SetProp(P_GHOST, 1);
      write("Du bist jetzt ein Geist...\n");
    }
    else
    {
      TP->SetProp(P_GHOST, 0);
      write("Du bist jetzt kein Geist mehr...\n");
    }
    return 1;
  }
}

reset()
{
  ::reset();
  if (abgehoben>0) abgehoben--;
}
