/* Kaefer
 * Samtpfote@tamedhon
 *
 */

#include <class.h> 
#include <properties.h>
#include <combat.h>
#include <moving.h>
#include <new_skills.h>

#ifdef LOG
#undef LOG
#endif
#define LOG(x, text) write_file("/log/statistik/npcs/"+x, text)

inherit "/std/mnpc";
inherit "/std/player/moneyhandler";

string *_query_racestring()
{
    if(QueryProp(P_GENDER) == MALE)
    {
	return ({"Kaefer", "Kaefers", "Kaefer", "Kaefer"});
    }
    else
    {
	return ({"Kaefer", "Kaefers", "Kaefer", "Kaefer"});
    }
}

void add_combat_spells()
{
    int level;
    
    level = QueryProp(P_LEVEL);

    AddSpell(3, level*10,
        this_object()->Name()+" krabbelt Dich schmerzhaft nieder.\n",
        this_object()->Name()+" krabbelt @WEN schmerzhaft nieder.\n",
        DT_BLUDGEON,
        ([SP_SHOW_DAMAGE: 1, SP_PHYSICAL_ATTACK: 1]));
    AddSpell(1, level*16,
        this_object()->Name()+" zwickt Dich mit den Zangen.\n",
        this_object()->Name()+" zwickt @WEN mit den Zangen.\n",
        DT_SQUEEZE,
        ([SP_SHOW_DAMAGE: 1, SP_PHYSICAL_ATTACK: 1]));
}

void create_default_kaefer(int level)
{
    int	num;

    ::create_default_npc(level);
    SetProp(P_SPELLRATE, 10+level/2+random(level*2)); 
    if(QueryProp(P_SPELLRATE) >= 100)
    { SetProp(P_SPELLRATE, 80+random(16)); }
    
    SetProp(P_KILL_NAME, this_object()->name());
    if(level <= 35+random(6))
    { 
	SetProp(P_ATTRIBUTES, 
	    ([A_CON: level+(random(level)/6)-(random(level)/6),
	      A_DEX: level+(random(level)/6)-(random(level)/6),
	      A_INT: level+(random(level)/6)-(random(level)/6),
	      A_STR: level+(random(level)/6)-(random(level)/6)
	    ]));
    }
    else
    {
	SetProp(P_ATTRIBUTES, ([A_CON: 35, A_DEX: 35, A_INT: 35, A_STR: 35]));
    }
    
    SetProp(P_BODY, (level<30?level*3:level*2)+random(15));
    SetProp(P_HANDS, 
	({" mit den Beisswerkzeugen",
	  10+(level/2)+random(10),
	  DT_SQUEEZE
	}));
    AddId("\nkaefer");
    AddId("kaefer");
    
    SetProp(P_GENDER, MALE);
    SetProp(P_NAME, "Kaefer");
    SetProp(P_RACE, "kaefer");
    SetProp(P_SHORT, "Ein unbeschriebener Kaefer");
    SetProp(P_LONG, "Das ist ein unbeschriebener Kaefer.\n");
    SetProp(P_AVERAGE_SIZE, 15);
    SetProp(P_SIZE, 12+random(9));
    SetProp(P_AVERAGE_WEIGHT, 2400);
    SetProp(P_WEIGHT, 2000+random(600));
    SetProp(P_ATTRIBUTES_OFFSETS, 
	([A_DEX: 0, A_CON: 2, A_INT: -1, A_STR: 3]));
    SetProp(P_MAX_HANDS, 0);
    SetProp(P_AGGRESSIVE, 0);
    SetProp(P_DEFAULT_INFO,
	({"krabbelt unruhig herum.\n",
          "wackelt mit dem Beisswerkzeugen.\n",
          "laeuft im Kreis.\n",
          "zwickt Dich in die Fuesse.\n"
	}));
    SetProp(P_LOG_INFO, 0);
    SetProp(P_RESISTANCE, 
        ({DT_SLASH, DT_PIERCE, DT_RIP, DT_WHIP, DT_TERROR }));
    SetProp(P_VULNERABILITY, ({ DT_SQUEEZE, DT_BLUDGEON }));
    SetProp(P_TEMPERATURE_RANGE, ([T_RANGE_MIN: 10, T_RANGE_MAX: 30]));  
    SetProp(P_NOMAGIC, 0);
    SetProp(P_WIMPY, 0);
    SetProp(P_DIE_MSG, 
        " bleibt zerquetscht am Boden liegen.\n");

    SetProp(P_MSGIN, "krabbelt herein");
    SetProp(P_MSGOUT, "krabbelt#");
    SetProp(P_MMSGIN, "setzt sich zusammen");
    SetProp(P_MMSGOUT, "zerfaellt zu Staub");
    
    SetProp(P_MAX_FOOD, 100);
    SetProp(P_MAX_ALCOHOL, 100);
    SetProp(P_MAX_DRINK, 100);
    
    SetProp(P_ALIGN, -random(100)+random(200));

    if(!is_class_member(CL_INSECT)) { AddClass(CL_INSECT); }
    if(!is_class_member(CL_BUG)) { AddClass(CL_BUG); }
    
    call_out("add_combat_spells", 3);
}

void create_default_npc(int level)
{ create_default_kaefer(level); }


int create()
{
    if(!is_clone(this_object())) return 0;
    ::create();
}
