/* Standardzwerg
 * Samtpfote@tamedhon
 *
 *
 */

#include <class.h> 
#include <properties.h>
#include <combat.h>
#include <moving.h>

#ifdef LOG
#undef LOG
#endif
#define LOG(x, text) write_file("/log/statistik/npcs/"+x, text)

#define RASSEARR ({"Ork", "Mensch", "Elf", "Troll", "Goblin", "Kobold" })

inherit "/std/mnpc";
inherit "/std/player/moneyhandler";

string *_query_racestring()
{
    if(QueryProp(P_GENDER) == MALE)
    {
	return ({"Zwerg", "Zwergs", "Zwerg", "Zwerg"});
    }
    else
    {
	return ({"Zwergin", "Zwergin", "Zwergin", "Zwergin"});
    }
}

void create_default_zwerg(int level)
{
    int	num;

    ::create_default_npc(level);
    SetProp(P_SPELLRATE, 10+level/2+random(level*2)); 
    if(QueryProp(P_SPELLRATE) >= 100)
    { SetProp(P_SPELLRATE, 80+random(16)); }

    if(level <= 35+random(6))
    { 
	SetProp(P_ATTRIBUTES, 
	    ([A_CON: level+(random(level)/6)-(random(level)/6),
	      A_DEX: level+(random(level)/6)-(random(level)/6),
	      A_INT: level+(random(level)/6)-(random(level)/6),
	      A_STR: level+(random(level)/6)-(random(level)/6)
	    ]));
    }
    else
    {
	SetProp(P_ATTRIBUTES, ([A_CON: 35, A_DEX: 35, A_INT: 35, A_STR: 35]));
    }
    
    SetProp(P_BODY, (level<30?level*2:level)+random(15));
    SetProp(P_HANDS, 
	({" mit geballten Faeusten",
	  40+(level/3)*10+random(10),
	  DT_BLUDGEON
	}));
    AddId("\nzwerg");
    AddId("zwerg");
    
    SetProp(P_GENDER, MALE);
    SetProp(P_NAME, "Zwerg");
    SetProp(P_RACE, "Zwerg");
    SetProp(P_SHORT, "Ein unbeschriebener Zwerg");
    SetProp(P_LONG, "Das ist ein unbeschriebener Zwerg.\n");
    SetProp(P_AVERAGE_SIZE, 120);
    SetProp(P_AVERAGE_WEIGHT, 50000);
    SetProp(P_SIZE, random(30)+108);
    SetProp(P_WEIGHT, 40000+random(20000));
    SetProp(P_ATTRIBUTES_OFFSETS, 
	([A_DEX: 2, A_CON: 4, A_INT: -3, A_STR: 3]));
    SetProp(P_MAX_HANDS, 2);
    SetProp(P_AGGRESSIVE, 
	([P_RACE:
	    (["Dunkelzwerg":	1.0,
	      "Kobold":		1.0,
	      "Troll":		0.8,
	      "Elf":		0.1,
	      "Ork":		0.3
	    ])
	]));
    SetProp(P_DEFAULT_INFO,
	({"zuckt ahnungslos mit den Schultern.\n",
	  "bohrt sich unwissend in die Nase.\n",
	  "hat davon keinen Schimmer.\n",
	  "interessiert sich nicht dafuer.\n",
	  "streicht sich durch den wallenden Rauschebart.\n",
	  "meint: Wenn Du mir dafuer Gold gibst, weiss ich vielleicht etwas.\n",
	  "fragt: Besteht das aus Gold?\n",
	  "antwortet: Bin doch kein stinkender "+
	    RASSEARR[random(sizeof(RASSEARR))]+
	    "!\n",
	  "moechte lieber einen guten Zwergenbock trinken.\n",
	  "grummelt Dich an.\n",
	  "rueckt sich die Bekleidung zurecht.\n",
	  "brummelt etwas ueber '"+RASSEARR[random(sizeof(RASSEARR))]+"' "+
	    "in den Bart.\n",
	  "gruebelt darueber nach, aber hat trotzdem keine Ahnung.\n"
	}));
    SetProp(P_LOG_INFO, 1);
    SetProp(P_RESISTANCE, ({DT_BLUDGEON, DT_FIRE, DT_MAGIC, DT_POISON}));
    SetProp(P_VULNERABILITY, ({DT_WATER}));
    SetProp(P_TEMPERATURE_RANGE, ([T_RANGE_MIN: 5, T_RANGE_MAX: 32]));  
    SetProp(P_NOMAGIC, 5);
    SetProp(P_WIMPY, 0);
    SetProp(P_DIE_MSG, " faellt wie ein Stein tot um.\n");

    SetProp(P_MSGIN, "stapft herein");
    SetProp(P_MSGOUT, "stapft#");
    SetProp(P_MMSGIN, "baut sich aus einem Steinhaufen auf");
    SetProp(P_MMSGOUT, "zwinkert Dich an und ist nicht mehr da");
    
    SetProp(P_MAX_FOOD, 80);
    SetProp(P_MAX_ALCOHOL, 90);
    SetProp(P_MAX_DRINK, 130);
    
    SetProp(P_ALIGN, -random(200)+random(200)-random(100)+random(100));
    
    AddClass(CL_HUMANOID);
    AddClass(CL_DWARF);        
}


void create_default_npc(int level)
{ create_default_zwerg(level); }


int create()
{
    if(!is_clone(this_object())) return 0;
    ::create();
}
