/* Tamedhon MUDLIB
 * Samtpfote@Tamedhon.at
 *
 * der Kerbholzmaster, verwaltet alle Kerbhoelzer und so
 */

#include <properties.h>
#include <wizlevels.h>
#include "./kerbholz.h"

#define DB(x)   "/room/debug"->debug_message(this_object(), x)

mapping kerbliste;

mixed sort_kerben(mixed a, mixed b)
{
    // DB(sprintf("a=%O",a));
    // DB(sprintf("b=%O",b));
    if(to_int(a[0]) < to_int(b[0])) 
    { return 1; }
    /*
    else if(to_int(a[1]) < to_int(b[1]))
    { return 1; }
    else if(to_string(a[2]) < to_string(b[2]))
    { return 1; }
    */
    
    return 0;
}

varargs 
void query_kerb_status(object who, int opts)
{
    string      text, *files, file;
    mapping     *mi;
    int         kls, k, sum_kills, sum_div,
                i, is, sum_total, sum_total_div,
                *kc;
    mixed       *data;

    if(!interactive(who)) return;
    if(!IS_ARCH(who)) return;

    mi=m_indices(kerbliste);    
    kls=sizeof(m_indices(kerbliste));

    files=({}); data=({});
    text=sprintf("\n%-20s   %5s   %5s\n", "SPIELER", "KILLS", "VERSCH");    
    sum_total=0;
    sum_total_div=0;
    
    for(k=0; k<kls; k++)
    {
        sum_kills = 0;
        kc = m_values(kerbliste[mi[k]]);
        is = sizeof(kc);
        if(is)
        { 
            for(i = 0; i<is; i++) 
            { 
                sum_kills+=kc[i]; 
                file=m_indices(kerbliste[mi[k]])[i];
                if(member(files, file) == -1)
                {
                    files+=({ file });
                }
            } 
        }
        
        sum_div=sizeof(m_indices(kerbliste[mi[k]]));        
        sum_total+=sum_kills;         

        data+=({ ({sum_kills, sum_div, capitalize((string)mi[k]) }) });
    }
    data=sort_array(data, #'sort_kerben);
    DB(sprintf("%O", data));
    
    for(k=0; k<kls; k++)
    {
        text+=sprintf("%-20s   %5i   %5i\n",
            to_string(data[k][2]), to_int(data[k][0]), to_int(data[k][1]));
    }
        
    sum_total_div=sizeof(files);
    text+=sprintf("\n%-20s   %5i   %5i\n", "TOTAL", sum_total, sum_total_div);
    
    who->More(text);
    
    //DB(sprintf("%O\n---------------------\n%O\n", kerbliste, files));
    
}

mapping query_kills(object killer)
{
    mapping     map;

    if(!killer) return 0;
    if(!interactive(killer)) return 0;
    
    if(!kerbliste[getuid(killer)])    
    {
        map=([]);
    }
    else
    {
        map=copy_mapping(kerbliste[getuid(killer)]);
    }
    // DB(sprintf("%O",map));
    return map;
}

int AddKill(object killer, object victim)
{
    mapping     killermap;
    string      pl, npc;

    if(!killer || !victim) return 0;
    if(!interactive(killer)) return 0;
    if(!victim->QueryProp(P_NPC)) return 0;
    
    killermap=kerbliste[getuid(killer)];
    npc=efun::explode(file_name(victim),"#")[0];
    pl=getuid(killer);
    if(!killermap)
    {
        //killermap = ([pl: ([npc: 1]));
        killermap = ([pl: 1]);
        killermap[pl] = ([npc: 1]);
        kerbliste = kerbliste + killermap;
        tell_object(killer, 
            "Du schnitzt Dir eine frische Kerbe in Dein Kerbholz!\n");
        tell_room(environment(killer),
            sprintf("%s schnitzt sich eine frische Kerbe in %s Kerbholz!\n",
                killer->Name(), killer->QueryPossPronoun(WESSEN)),
            ({ killer }));
    }
    else
    {
        if(killermap[npc])
        {
            kerbliste[pl][npc]=kerbliste[pl][npc]+1;
            tell_object(killer, 
                "Du schnitzt Dir eine weitere Kerbe in Dein Kerbholz!\n");
            tell_room(environment(killer),
                sprintf("%s schnitzt sich eine weitere Kerbe in %s Kerbholz!\n",
                    killer->Name(), killer->QueryPossPronoun(WESSEN)),
                ({ killer }));;            
        }
        else
        {
            kerbliste[pl][npc]=1;
            tell_object(killer, 
                "Du schnitzt Dir eine frische Kerbe in Dein Kerbholz!\n");
            tell_room(environment(killer),
                sprintf("%s schnitzt sich eine frische Kerbe in %s Kerbholz!\n",
                    killer->Name(), killer->QueryPossPronoun(WESSEN)),
                ({ killer }));;
        }
    }
    
    // DB(sprintf("%O",kerbliste));
}

void remove()
{
    save_object(KERBEN_SAVEFILE);
}

void reset()
{
    save_object(KERBEN_SAVEFILE);
}

void create()
{
    kerbliste = ([]);
    seteuid(getuid());
    restore_object(KERBEN_SAVEFILE);
}
