/* das neue Partybrett
 * sweet 'n' simple
 *
 * Samtpfote@Tamedhon, Wed May 10 15:01:53 2000
 * $Date: 2000/06/11 21:26:52 $
 * $Revision: 1.3 $
 * $Log: partybrett.c,v $
 * Revision 1.3  2000/06/11 21:26:52  Samtpfote
 * pfad vom savefile angepast
 *
 * Revision 1.2  2000/05/31 11:22:11  Samtpfote
 * bugfix von party abmelden
 *
 * Revision 1.1  2000/05/28 09:00:12  Samtpfote
 * Initial revision
 *
 */
#include <properties.h>
#include <daemon.h>
#include <material.h>
#include <wizlevels.h>

inherit "/std/thing";
inherit "/mail/nedit";

#define LOGFILE		"/log/PARTY"
#define SAVEFILE	"/p/service/samtpfote/party/partybrett"
#define VERSION		"$Revision: 1.3 $"
#define COLW		72

#define TO		this_object()
#define TP		this_player()

string	partytext, partyort, partycreator;
string	partydate;
string	*partyteilnehmer;
int	anzteilnehmer;


varargs string liste(string *str, string pad) 
{
    if (!sizeof(str)) { return ""; }
    if (sizeof(str) == 1) { return str[0]; }
    return implode(str[0..<2], ", ")+(pad ? pad : " und " )+str[<1];
}


int brett_status(string str)
{
    if(!IS_LORD(TP))
    {
	write("Dafuer musst du schon RM sein.\n");
	return 0;
    }
    
    printf("partytext=%s\n", partytext);
    printf("partyort=%s\n", partyort);
    printf("partydate=%s\n", partydate);
    printf("partycreator=%s\n", partycreator);
    printf("partyteilnehmer=%s\n", liste(partyteilnehmer));
    printf("anzteilnehmer=%i\n", anzteilnehmer);
    
    return 1;
}

void infokanal(string msg)
{
    catch(VOICEMASTER->SendToChannel("Info",this_object(),SAY,msg));
}

int spieler_anmelden(string str)
{
    string plname;

    plname=capitalize(TP->query_real_name());

    if(partycreator == "")
    {
	notify_fail("Es ist keine Party angemeldet!\n");
	return 0;
    }

    if(TP->QueryProp(P_SECOND) || (TP->QueryProp(P_TESTPLAYER)))
    {
	notify_fail("Benutze lieber deine Erstfigur zur Anmeldung!\n");
	return 0;
    }

    if(member(partyteilnehmer, plname) != -1)
    {
	notify_fail("Du hast Dich bereits an der Party angemeldet!\n");
	return 0;
    }
    
    write("Ok, Du meldest Dich fuer die Party an.\n");
    say(plname+" meldet sich zur Party "+
	"an!\n", TP);
        
    partyteilnehmer=partyteilnehmer+({ plname });
    anzteilnehmer=sizeof(partyteilnehmer);
    save_object(SAVEFILE);
    infokanal(plname+" hat sich zur Party am "+partydate+
              " angemeldet!");
            
    return 1;
}

int spieler_abmelden(string str)
{
    string plname;

    plname=capitalize(TP->query_real_name());

    if(partycreator == "")
    {
	notify_fail("Es ist keine Party angemeldet!\n");
	return 0;
    }

    if(member(partyteilnehmer, plname) == -1)
    {
	notify_fail("Du bist gar nicht an der Party angemeldet!\n");
	return 0;
    }
    
    if(TP->QueryProp(P_SECOND) || (TP->QueryProp(P_TESTPLAYER)))
    {
	notify_fail("Benutze lieber deine Erstfigur zur Abmeldung!\n");
	return 0;
    }
    
    write("Ok, Du meldest Dich von der Party ab.\n");
    say(plname+" meldet sich von der Party ab!\n", TP);
    
    partyteilnehmer=partyteilnehmer-({ plname });
    anzteilnehmer=sizeof(partyteilnehmer);
    save_object(SAVEFILE);
    infokanal(plname+" hat von der Party am "+partydate+
              " abgemeldet!");        
    
    return 1;
}

party_absagen(string janein)
{
    string	plname;

    if(janein != "ja") 
    {
	write("*** Abgebrochen!\n");
	return;
    }
    
    partycreator="";
    partytext="";
    partydate=0;
    partyteilnehmer=({});
    anzteilnehmer=0;
    
    plname=capitalize(TP->query_real_name());
    write("Ok, Du hast die Party abgebrochen!\n");
    say(plname+" bricht die Party ab!\n");
    
    save_object(SAVEFILE);
    infokanal(plname+" hat eine die Party, die am "+partydate+
	      " stattfindet, abgesagt!");
}

party_anmelden_fertig(string str)
{
    string	plname;
    string	*pt;
    int		i, is;

    if(!str ||(str==""))
    {
	write("Ok, abgebrochen!\n");
	return;
    }
    
    plname=capitalize(TP->query_real_name());    
    is=sizeof(pt=efun::explode(str, "\n"));
    if(is)
    for(i=0; i<is; i++)
    {
	pt[i]="| "+pt[i][0..COLW-1];
    }   
    partytext=implode(pt, "\n");
    write("Ok, Du hast eine neue Party angekuendigt!\n");
    say(plname+" hat eine neue Party angekuendigt!\n");

    save_object(SAVEFILE);
    infokanal(plname+" hat eine neue Party angemeldet!");
}

party_date(string str)
{
    if(str == "~q")
    {
	write("Ok, abgebrochen.\n");
    }
    
    write("Bitte jetzt den Partytext eingeben, mit einer Beschreibung "+
          "und allen Drum und Dran halt, was man so dann mit 'unt "+
	  "brett' sieht. Abgeschlossen wird es mit '.' bzw abgebrochen "+
	  "mit '~q'. Achtung! Der Text wird ab der "+
	  to_string(COLW)+". Spalte abgeschnitten.\n");
    nedit("party_anmelden_fertig");
}

int party_cmds(string str)
{
    string	plname;

    notify_fail("Syntax: party (ankuendigen | absagen)\n");
    if(!str || (str == ""))
    {
	return 0;
    }
    
    plname=capitalize(TP->query_real_name());
        
    if(str == "absagen")
    {
	if(partycreator == "")
	{
	    notify_fail("Es ist keine Party angemeldet!\n");
	    return 0;
	}
    
	if(plname != partycreator) 
	{
	    notify_fail("Nur derjenige, der die Party angemeldet hat, "+
		        "kann sie auch wieder absagen!\n");
	    return 0;			
	}
    
	write("Bist du Dir SICHER, dass du die Party absagen willst "+
	      "(ja / nein)?\n>");
	input_to("party_absagen");
	return 1;
    }    
    
    if(str == "ankuendigen")
    {
	if(partycreator != "")
	{
	    notify_fail("Es ist bereits eine Party angekuendigt!\n");
	    return 0;
	}
	
	partycreator=plname;
	
	write("Partydatum: ");
	input_to("party_date");
	return 1;
    }
    
    return 0;
}


string long()
{
    string	ret;
    
    ret=
	"TAMEDHON-PARTYBRETT\n"+
	"+-----------------------------------------------------------+\n";
	
    if(partycreator == "")
    {
	ret+="Es ist derzeit keine Party angemeldet.\n";
    }
    else
    {
	ret+=partytext+"\n";
	if(!anzteilnehmer) 
	{
	    ret+="Es hat sich noch niemand fuer die Party "+
		 "angemeldet.\n";
	}
	else
	{
	    ret+="Derzeit haben sich "+anzteilnehmer+" Spieler "+
	         "angemeldet:\n"+
		 break_string(liste(partyteilnehmer)+".")+"\n";
	}
    }
	
    ret+="\nAm Rand ist ein ein kleiner gelber Partyzettel befestigt "+
	      "worden.\n";	
	
    return ret;
}

void create()
{
    if(!is_clone(TO)) return;
    ::create();
    
    AddId(({"\npartybrett", "partybrett", "brett"}));
    SetProp(P_GENDER, NEUTER);
    SetProp(P_NAME, "Partybrett");
    SetProp(P_SHORT, "Das Tamedhon-Partybrett");
    
    SetProp(P_NOGET, "Das Partybrett ist fest an die Wand "+
		     "angenagelt worden.\n");
    SetProp(P_MATERIAL, ([MAT_OAK: 80, MAT_PAPER: 20]));

    partycreator="";
    partytext="";
    partydate="";
    partyort="";
    partyteilnehmer=({});
    anzteilnehmer=0;
    
    AddDetail("partyzettel", "Lies ihn doch mal.\n");
    AddReadDetail("partyzettel",
	"Hier ist wohl eine Anleitung, was man so am Partybrett alles "+
	"machen kann.\n\n"+
	"  party (ankuendigen | absagen) \n"+
	"  anmelden           zur Party kommen\n"+
	"  abmelden           sich von der Party abmelden\n"+
	"\n\n"+
	"Tamedhon-Partybrett "+VERSION+" by Samtpfote@Tamedhon.\n\n");
    
    AddCmd("anmelden", "spieler_anmelden");
    AddCmd("abmelden", "spieler_abmelden");
    AddCmd("party", "party_cmds");

    AddCmd("brettstatus", "brett_status");
    
    seteuid(getuid(TO));
    restore_object(SAVEFILE);
}