/* Standardfile einer werfbaren Waffe, 
 * Originalversion von Paracelsus@MG
 *
 * Anpassung ans Turithil von Samtpfote
 */
#pragma strict
#pragma strong-types

#include <properties.h>
#include <language.h>
#include <moving.h>

#define TO		this_object()
#define TP		this_player()
#define BS(x)		break_string(x)
#define ETP		environment(this_player())
#define ETO		environment(this_object())
#define TPN(x)		this_player()->name(x)

#define ENV(x)		environment(x)

inherit "/std/weapon";

int create()
{   
    if(!is_clone(this_object())) { return 0; }
    ::create();
    SetProp(P_SHORT, "Eine Wurfwaffe");
    SetProp(P_THROWING_WEAPON, 1);
}

throw_it(string in)
{   object en;
    string was,wer;
    int i,de,dp;

    notify_fail("Du musst "+name(WEN,1)+" schon zuecken.\n");
    if (!QueryWielded()) return 0;
    if (QueryWielded()!=TP) return 0;
    if (TP->QueryProp(P_ATTACK_BUSY))
    {   write("Du bist schon zu beschaeftigt.\n");
        return 1;
    }
    notify_fail("Was willst Du werfen ?\n");
    if (!in) return 0;
    if (id(in))
    {   notify_fail(BS(
            "Wenn Du nicht kaempfst, musst Du schon sagen, auf wen Du "+
            "werfen willst."));
        if (!(TP->InFight())) return 0;
        en = TP->SelectEnemy();
    }
    else
    {   if (sscanf(in,"%s auf %s",was,wer)!=2 &&
            sscanf(in,"%s nach %s",was,wer)!=2) return 0;
        if (!id(was)) return 0;
        en = present(wer,ETP);
    }
    notify_fail("Auf wen willst Du werfen ?\n");
    if (!en) return 0;
    DoUnwield(1);
    TP->SetProp(P_ATTACK_BUSY,1);
    write(BS("Du wirfst "+name(WEN,1)+" auf "+en->name(WEN,1)+"."));
    say(BS(capitalize(TPN(WER))+" wirft "+name(WEN,1)+" auf "+
        en->name(WEN,1)+"."),({ TP,en }));
    tell_object(en,BS(capitalize(TPN(WER))+" wirft "+name(WEN,1)+
        " nach Dir.") );
    i = random(100);
    de = en->QueryAttribute(A_DEX);
    dp = TP->QueryAttribute(A_DEX);
    if ((2*de)>(3*dp))
    {   tell_room(ETP,
            capitalize(en->name(WER,1))+" faengt "+name(WEN,1)+
            " geschickt auf.\n",({en}));
        tell_object(en,
            "Du faengst "+name(WEN,1)+" geschickt auf.\n");
        if (move(en,M_SILENT)==ME_TOO_HEAVY)
        {   move(ENV(en),M_NOCHECK);
            tell_object(en,capitalize(name(WER,1))+
                " ist Dir zu schwer und Du laesst "+
                QueryPronoun(WEN)+" fallen.\n");
            tell_room(ENV(en),capitalize(en->name(WER,1))+
                " laesst "+name(WEN,1)+" wieder fallen.\n",({ en }));
        }
        return 1;
    }
    if (((2*dp)>(3*de))||((7*dp/2)>i))
    {   write("Du triffst "+en->name(WEN,1)+".\n");
        say(capitalize(TPN(WER))+" trifft "+en->name(WEN,1)+".\n",
            ({ en,TP }) );
        tell_object(en,capitalize(TPN(WER))+" trifft Dich.\n");
        i  = 4*TP->QueryRealAttribute(A_STR);
        i += 2*TP->QueryRealAttribute(A_DEX);
        i += 2*TP->QueryRealAttribute(A_CON);
        i += 2*TP->QueryRealAttribute(A_INT);
        i *= QueryProp(P_WC);
        i /= 50; // Max. 4facher WC-Schaden
        en->Defend(i,QueryProp(P_DAM_TYPE),1,TP);
        if (move(en,M_SILENT)==ME_TOO_HEAVY)
        {   tell_room(ENV(en),capitalize(name(WER,1))+
                " faellt zu Boden.\n");
            move(ENV(en),M_NOCHECK);
        }
        return des_test();
    }
    write("Du verfehlst "+en->name(WEN,1)+".\n");
    say(capitalize(TPN(WER))+" wirft daneben.\n");
    tell_room(ENV(en),capitalize(name(WER,1))+" faellt zu Boden.\n");
    move(ENV(TP),M_NOCHECK);
    return des_test();
}

init()
{   ::init();
    add_action("throw_it","wirf");
    add_action("throw_it","werfe");
    add_action("throw_it","schleuder");
    add_action("throw_it","schleudere");
}

int des_test()
{   if (random(100)>42) return 1;
    tell_object(ETO,capitalize(name(WER,1))+" zerbricht.\n");
    call_out("remove",1);
    return 1;
}
